Merge tag 'block-6.13-20242901' of git://git.kernel.dk/linux
[drm/drm-misc.git] / scripts / link-vmlinux.sh
blobd853ddb3b28c1238ec9079ebbbe77df26980a0a1
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
4 # link vmlinux
6 # vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7 # vmlinux.a contains objects that are linked unconditionally.
8 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9 # (not within --whole-archive), and do not require symbol indexes added.
11 # vmlinux
12 # ^
13 # |
14 # +--< vmlinux.a
15 # |
16 # +--< $(KBUILD_VMLINUX_LIBS)
17 # | +--< lib/lib.a + more
18 # |
19 # +-< ${kallsymso} (see description in KALLSYMS section)
21 # vmlinux version (uname -v) cannot be updated during normal
22 # descending-into-subdirs phase since we do not yet know if we need to
23 # update vmlinux.
24 # Therefore this step is delayed until just before final link of vmlinux.
26 # System.map is generated to document addresses of all kernel symbols
28 # Error out on error
29 set -e
31 LD="$1"
32 KBUILD_LDFLAGS="$2"
33 LDFLAGS_vmlinux="$3"
35 is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
39 # Nice output in kbuild format
40 # Will be supressed by "make -s"
41 info()
43 printf " %-7s %s\n" "${1}" "${2}"
46 # Link of vmlinux
47 # ${1} - output file
48 vmlinux_link()
50 local output=${1}
51 local objs
52 local libs
53 local ld
54 local ldflags
55 local ldlibs
57 info LD ${output}
59 # skip output file argument
60 shift
62 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
63 # Use vmlinux.o instead of performing the slow LTO link again.
64 objs=vmlinux.o
65 libs=
66 else
67 objs=vmlinux.a
68 libs="${KBUILD_VMLINUX_LIBS}"
71 if is_enabled CONFIG_GENERIC_BUILTIN_DTB; then
72 objs="${objs} .builtin-dtbs.o"
75 if is_enabled CONFIG_MODULES; then
76 objs="${objs} .vmlinux.export.o"
79 objs="${objs} init/version-timestamp.o"
81 if [ "${SRCARCH}" = "um" ]; then
82 wl=-Wl,
83 ld="${CC}"
84 ldflags="${CFLAGS_vmlinux}"
85 ldlibs="-lutil -lrt -lpthread"
86 else
87 wl=
88 ld="${LD}"
89 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
90 ldlibs=
93 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
95 # The kallsyms linking does not need debug symbols included.
96 if [ -n "${strip_debug}" ] ; then
97 ldflags="${ldflags} ${wl}--strip-debug"
100 if is_enabled CONFIG_VMLINUX_MAP; then
101 ldflags="${ldflags} ${wl}-Map=${output}.map"
104 ${ld} ${ldflags} -o ${output} \
105 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
106 ${wl}--start-group ${libs} ${wl}--end-group \
107 ${kallsymso} ${btf_vmlinux_bin_o} ${arch_vmlinux_o} ${ldlibs}
110 # generate .BTF typeinfo from DWARF debuginfo
111 # ${1} - vmlinux image
112 gen_btf()
114 local btf_data=${1}.btf.o
116 info BTF "${btf_data}"
117 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
119 # Create ${btf_data} which contains just .BTF section but no symbols. Add
120 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
121 # deletes all symbols including __start_BTF and __stop_BTF, which will
122 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
123 # objcopy warnings: "empty loadable segment detected at ..."
124 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
125 --strip-all ${1} "${btf_data}" 2>/dev/null
126 # Change e_type to ET_REL so that it can be used to link final vmlinux.
127 # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
128 if is_enabled CONFIG_CPU_BIG_ENDIAN; then
129 et_rel='\0\1'
130 else
131 et_rel='\1\0'
133 printf "${et_rel}" | dd of="${btf_data}" conv=notrunc bs=1 seek=16 status=none
135 btf_vmlinux_bin_o=${btf_data}
138 # Create ${2}.o file with all symbols from the ${1} object file
139 kallsyms()
141 local kallsymopt;
143 if is_enabled CONFIG_KALLSYMS_ALL; then
144 kallsymopt="${kallsymopt} --all-symbols"
147 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
148 kallsymopt="${kallsymopt} --absolute-percpu"
151 info KSYMS "${2}.S"
152 scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
154 info AS "${2}.o"
155 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
156 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
158 kallsymso=${2}.o
161 # Perform kallsyms for the given temporary vmlinux.
162 sysmap_and_kallsyms()
164 mksysmap "${1}" "${1}.syms"
165 kallsyms "${1}.syms" "${1}.kallsyms"
167 kallsyms_sysmap=${1}.syms
170 # Create map file with all symbols from ${1}
171 # See mksymap for additional details
172 mksysmap()
174 info NM ${2}
175 ${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
178 sorttable()
180 ${objtree}/scripts/sorttable ${1}
183 cleanup()
185 rm -f .btf.*
186 rm -f System.map
187 rm -f vmlinux
188 rm -f vmlinux.map
191 # Use "make V=1" to debug this script
192 case "${KBUILD_VERBOSE}" in
193 *1*)
194 set -x
196 esac
198 if [ "$1" = "clean" ]; then
199 cleanup
200 exit 0
203 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
205 arch_vmlinux_o=
206 if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
207 arch_vmlinux_o=arch/${SRCARCH}/tools/vmlinux.arch.o
210 btf_vmlinux_bin_o=
211 kallsymso=
212 strip_debug=
214 if is_enabled CONFIG_KALLSYMS; then
215 true > .tmp_vmlinux0.syms
216 kallsyms .tmp_vmlinux0.syms .tmp_vmlinux0.kallsyms
219 if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
221 # The kallsyms linking does not need debug symbols, but the BTF does.
222 if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
223 strip_debug=1
226 vmlinux_link .tmp_vmlinux1
229 if is_enabled CONFIG_DEBUG_INFO_BTF; then
230 if ! gen_btf .tmp_vmlinux1; then
231 echo >&2 "Failed to generate BTF for vmlinux"
232 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
233 exit 1
237 if is_enabled CONFIG_KALLSYMS; then
239 # kallsyms support
240 # Generate section listing all symbols and add it into vmlinux
241 # It's a four step process:
242 # 0) Generate a dummy __kallsyms with empty symbol list.
243 # 1) Link .tmp_vmlinux1.kallsyms so it has all symbols and sections,
244 # with a dummy __kallsyms.
245 # Running kallsyms on that gives us .tmp_vmlinux1.kallsyms.o with
246 # the right size
247 # 2) Link .tmp_vmlinux2.kallsyms so it now has a __kallsyms section of
248 # the right size, but due to the added section, some
249 # addresses have shifted.
250 # From here, we generate a correct .tmp_vmlinux2.kallsyms.o
251 # 3) That link may have expanded the kernel image enough that
252 # more linker branch stubs / trampolines had to be added, which
253 # introduces new names, which further expands kallsyms. Do another
254 # pass if that is the case. In theory it's possible this results
255 # in even more stubs, but unlikely.
256 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
257 # other bugs.
258 # 4) The correct ${kallsymso} is linked into the final vmlinux.
260 # a) Verify that the System.map from vmlinux matches the map from
261 # ${kallsymso}.
263 # The kallsyms linking does not need debug symbols included.
264 strip_debug=1
266 sysmap_and_kallsyms .tmp_vmlinux1
267 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
269 vmlinux_link .tmp_vmlinux2
270 sysmap_and_kallsyms .tmp_vmlinux2
271 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
273 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
274 vmlinux_link .tmp_vmlinux3
275 sysmap_and_kallsyms .tmp_vmlinux3
279 strip_debug=
281 vmlinux_link vmlinux
283 # fill in BTF IDs
284 if is_enabled CONFIG_DEBUG_INFO_BTF; then
285 info BTFIDS vmlinux
286 ${RESOLVE_BTFIDS} vmlinux
289 mksysmap vmlinux System.map
291 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
292 info SORTTAB vmlinux
293 if ! sorttable vmlinux; then
294 echo >&2 Failed to sort kernel tables
295 exit 1
299 # step a (see comment above)
300 if is_enabled CONFIG_KALLSYMS; then
301 if ! cmp -s System.map "${kallsyms_sysmap}"; then
302 echo >&2 Inconsistent kallsyms data
303 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
304 exit 1
308 # For fixdep
309 echo "vmlinux: $0" > .vmlinux.d